import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, ViewChild, NgModule } from '@angular/core';
import { JSONEditor } from 'vanilla-jsoneditor';

class JsonEditorService {
    constructor() { }
}
JsonEditorService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
JsonEditorService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class JsonEditorComponent {
    constructor() {
        this.readOnly = false;
        this.options = {};
        this.debug = false;
        this.changeContent = new EventEmitter();
        this.changeText = new EventEmitter();
    }
    set jsonData(value) {
        this._jsonData = value;
        if (this.editorRef) {
            this.editorRef.destroy();
            this.ngOnInit();
        }
    }
    ;
    ngOnInit() {
    }
    ngAfterViewInit() {
        this.editorRef = new JSONEditor({
            target: this.editor.nativeElement,
            props: {
                content: this._jsonData,
                readOnly: this.readOnly,
                onChange: (e) => this.emitChange(e, this),
                ...this.options,
            }
        });
    }
    emitChange(d, x) {
        try {
            if (this.debug) {
                console.log(d);
            }
            if (this.changeContent) {
                x.changeContent.emit(d);
            }
            let t = d;
            if (t.json) {
                if (this.debug) {
                    console.log(t.json);
                }
                x.changeText.emit(JSON.stringify(t.json));
            }
            else {
                let h = d;
                if (this.debug) {
                    console.log(h.text);
                }
                x.changeText.emit(h.text);
            }
        }
        catch (e) {
            if (this.debug) {
                console.log(e);
            }
        }
    }
    expandAll() {
        this.editorRef.expand();
    }
    get() {
        return this.editorRef.get();
    }
    get instance() {
        return this.editorRef;
    }
    getText() {
        let d = this.editorRef.get();
        let returnText;
        let t = d;
        if (t.json) {
            if (this.debug) {
                console.log(t.json);
            }
            returnText = JSON.stringify(t.json);
        }
        else {
            let h = d;
            if (this.debug) {
                console.log(h.text);
            }
            returnText = h.text;
        }
        return returnText;
    }
    ngOnDestroy() {
        this.destroy();
    }
    isValidJson() {
        try {
            JSON.parse(this.getText());
            return true;
        }
        catch (e) {
            return false;
        }
    }
    destroy() {
        this.editorRef?.destroy();
    }
}
JsonEditorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
JsonEditorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: JsonEditorComponent, selector: "aero-jsonEditor", inputs: { jsonData: "jsonData", readOnly: "readOnly", options: "options", debug: "debug" }, outputs: { changeContent: "changeContent", changeText: "changeText" }, viewQueries: [{ propertyName: "editor", first: true, predicate: ["jsonEditor"], descendants: true }], ngImport: i0, template: `
    <div className="svelte-jsoneditor-react" #jsonEditor></div>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'aero-jsonEditor', template: `
    <div className="svelte-jsoneditor-react" #jsonEditor></div>
  ` }]
        }], ctorParameters: function () { return []; }, propDecorators: { jsonData: [{
                type: Input,
                args: ['jsonData']
            }], readOnly: [{
                type: Input
            }], options: [{
                type: Input
            }], debug: [{
                type: Input
            }], changeContent: [{
                type: Output
            }], changeText: [{
                type: Output
            }], editor: [{
                type: ViewChild,
                args: ['jsonEditor']
            }] } });

class JsonEditorModule {
}
JsonEditorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
JsonEditorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorModule, declarations: [JsonEditorComponent], exports: [JsonEditorComponent] });
JsonEditorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: JsonEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        JsonEditorComponent
                    ],
                    imports: [],
                    exports: [
                        JsonEditorComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of json-editor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { JsonEditorComponent, JsonEditorModule, JsonEditorService };
//# sourceMappingURL=ng-svelt-json-editor.mjs.map
